"use strict";
const assert = require("assert");
async function assertThrows(f, _arg1, // this is ~= "typeof E"
_arg2) {
    let result;
    let errorType = undefined;
    let errorCheck = undefined;
    if (!_arg1) {
        // pass
    }
    else if (Error.isPrototypeOf(_arg1)) {
        errorType = _arg1;
    }
    else {
        errorCheck = _arg1;
    }
    if (!_arg2) {
        // pass
    }
    else {
        errorCheck = _arg2;
    }
    try {
        result = await f();
    }
    catch (err) {
        if (errorType) {
            if (err instanceof errorType) {
                // ok
            }
            else {
                throw err;
            }
        }
        if (errorCheck) {
            if (typeof errorCheck === 'string') {
                if (err.message !== errorCheck) {
                    throw err;
                }
            }
            else if (typeof errorCheck === 'function') {
                if (errorCheck(err) === false) {
                    throw err;
                }
            }
            else if (errorCheck instanceof RegExp) {
                assert(errorCheck.test(err.message), `"${err.message}" does not match "${errorCheck.source}"`);
            }
            else {
                throw new TypeError('ErrorCheck needs to be a string, (Error) => bool, or regex.');
            }
        }
        return;
    }
    throw new assert.AssertionError({ message: 'Expected to throw', expected: errorType, actual: result });
}
module.exports = assertThrows;
//# sourceMappingURL=assertThrowsAsync.js.map